//
// μưбդ(ver.2.1)
//	ʿ14ǯ81

#include        <iostream>
#include        <cstdlib>

using namespace std;

#include	"CImage.h"
#include	"Mat.h"
#include	"Corresp_cls.h"

#include	"homography.h"
#include	"fundamental.h"
#include	"init_match.h"
#include	"set_probs.h"
#include	"eval_cnstr.h"
#include	"modelsel.h"
#include	"enforce_uniq.h"
#include	"automatch.h"
#include	"ransac_f.h"
#include	"print_funcs.h"
#include	"sort_funcs.h"
#include	"recalc.h"
#include	"matcher_consts.h"

// а첽ΤΥե饰ꥻå
void
reset_flag(CrpPair cp[], int N)
{
   for (int i = 1; i <= N; i++)
      cp[i].flag = 1;
}

// ƤγΨ֤ͤˤ
void
reset_Plmds(CrpPair cp[], int N)
{
   // Ψͤν
   cp[0].Plmd = cp[0].P0lmd = cp[0].P1lmd = cp[0].P2lmd = 0.0;
   cp[0].flag = 0;
   for (int i = 1; i <= N; i++)
   {
      cp[i].P0lmd = cp[i].P1lmd = cp[i].P2lmd = 1.0;
      cp[i].flag = 1;
   }
}

// P_lambda 򥻥å
void
calc_Plambda(CrpPair cp[], int N)
{
   reset_flag(cp, N);

   for (int i = 1; i <= N; i++)
   {
      cp[i].Plmd = cp[i].P0lmd * cp[i].P1lmd * cp[i].P2lmd;
   }
}

// γݤۤ
void
alloc_and_set_vec(Point pa[], int N, int width, int height, double fl,
		  VecC **Xa)
{
   int	w2, h2;

   // Xa γ
   *Xa = new VecC [N];

   // ɸϤѴ
   w2 = width / 2;
   h2 = height / 2;
   for (int i = 0; i < N; i++)
   {
      (*Xa)[i][0] = (double)(h2 - pa[i].v) / fl;
      (*Xa)[i][1] = (double)(pa[i].u - w2) / fl;
      (*Xa)[i][2] = 1.0;
   }
}

// ٥ȥΥԡ(ΨϽ)
void
copy_vecs_wo_pp(CrpPair cp[], int N, int N1,
	       VecC Xa0[], VecC Xb0[], VecC Xa[], VecC Xb[])
{
   int	j;

   // ԡɸϤѴ
   j = 0;
   for (int i = 1; i <= N; i++)
   {
      if (cp[i].flag)
      {
	 Xa[j] = Xa0[cp[i].a];
	 Xb[j] = Xb0[cp[i].b];
	 if (++j > N1)
	 {
	    cerr << "copy vec: error" << endl;
	    break;
	 }
      }
   }
}


// ưб׻
int
automatcher(CImage& CIm1, CImage& CIm2,
	    double d, double fl, int max_corner, int tp_size,
	    Mat& A0, CrpPair **CP, int *Ncp,
	    Point **pa0, int *Na0, Point **pb0, int *Nb0,
            int ImpHrsFlag, int normflag, int verbose)
{
   CrpPair	*cp, *ncp, *nncp;
   int		N, N0, N1, L;		// бФθĿ
   int		NN, NNN;
   double	k = 3;
   double	kl = 3;
   double	dthd, kthd, s;
   Point	*pa, *pb;		// ħ(ɸ)
   int		Na, Nb;
   VecC		*Xa0, *Xb0, *Xan, *Xbn;		// ħ(٥ȥ)
   int		width, height;
   int		Fflag;
   double	ret;

   Mat		F0, H0;		// «
   Mat		F1, H, F, Hn;

   // 쥤Ѵ
   Image	Im1(CIm1.width(), CIm1.height());
   Image	Im2(CIm2.width(), CIm2.height());

   CImagetoImage(CIm1, Im1);
   CImagetoImage(CIm2, Im2);

   width = Im1.width();
   height = Im1.height();
   CImage_set_quiet();	// ΰ賰ץåɽ

   // бɽȳΨͤۤ
   initial_matching(Im1, Im2, &pa, &pb, &Na, &Nb, &cp, &N, max_corner,
                    ImpHrsFlag, tp_size, normflag);

   if (verbose)
   {
      print_features(pa, Na, "image-1");
      print_features(pb, Nb, "image-2");
   }

   // ħɸ٥ȥؤѴ
   alloc_and_set_vec(pa, Na, width, height, fl, &Xa0);
   alloc_and_set_vec(pb, Nb, width, height, fl, &Xb0);

   //  s õ()
   L = (Na < Nb)? Na: Nb;
   s = newton_search_s(cp, N, L);

   // ĺΨP0
   reset_Plmds(cp, N);
   set_P0lmd(cp, N, s);

   // سΨ
   calc_Plambda(cp, N);
   qsort(cp + 1, N, sizeof(CrpPair), cmpPl);
   kthd = exp(-1.0 * k * k / 2.0);
   N0 = make_one2one_pl(cp, N, kthd);
   if (verbose)
      print_pairs(cp, N, pa, pb, "tp");
   set_P1lmd(cp, N, N0, pa, pb);   // سΨP1

   // «
   calc_Plambda(cp, N);
   qsort(cp + 1, N, sizeof(CrpPair), cmpPl);
   kthd = exp(-2.0 * k * k / 2.0);
   N1 = make_one2one_pl(cp, N, kthd);
   if (verbose)
      print_pairs(cp, N, pa, pb, "tpsc");
   eval_constraint_H(cp, N, N1, Xa0, Na, Xb0, Nb, H0);	// H ˴ؤ빴«
   set_P2lmd(cp, N, N1, L);				// ΨP2

   // RANSAC
   calc_Plambda(cp, N);
   qsort(cp + 1, N, sizeof(CrpPair), cmpPl);
   NN = extract_one2one_pair(cp, N, kthd, &ncp);
   if (verbose)
      print_pairs(ncp, NN, pa, pb, "bf-ransac");
   dthd = 2.0 * d * d / (fl * fl);
   ret = ransac_fund(ncp, NN, Xa0, Na, Xb0, Nb, width, height,
		     dthd, fl, MAX_ITR, F1, verbose);
   if (ret < 0.0)
   {
      cerr << "ransac_fund(): failed!" << endl;
      *CP = 0; *Ncp = 0;
      return -1;
   }

   // Ʒ׻
   kthd = exp(-3.0 * kl * kl / 2.0);
   recalc_FH(cp, N, Xa0, Xb0, dthd, kthd, fl, F1,
	     &nncp, &NNN, &Xan, &Xbn, F, H);

   // Ƚ
   model_selection(Xan, Xbn, NNN, F, H, &Fflag);

   if (Fflag)
   {
      if (verbose)
      {
	 print_pairs(nncp, NNN, pa, pb, "final");
	 cerr << "--- fundamental matrix ---" << endl;
      }
      A0 = F;
   }
   else
   {
      if (verbose)
	 cerr << "--- homography matrix ---" << endl;
      if (nncp) delete [] nncp;
      kthd = exp(- k * k / 2.0);
      rematch_and_calc_H(cp, N, Xa0, Xb0, dthd, kthd, fl, H, Hn, &nncp, &NNN);
      if (verbose)
	 print_pairs(nncp, NNN, pa, pb, "final");
      A0 = Hn;
   }
   if (verbose)
      cerr << "A0 = " << A0 << endl;

   *pa0 = pa;
   *Na0 = Na;
   *pb0 = pb;
   *Nb0 = Nb;
   *CP = nncp;
   *Ncp = NNN;
   return Fflag;
}
