//
// μưбդ(ver.1.3)
//	ʿ14ǯ615

// Ƽإƥ

#include <iostream>
#include <cmath>

using namespace std;

#include "Mat.h"

#include "affine_ls.h"
#include "Corresp_cls.h"

//// бζƥ

// ٴؿ
static double
ang(VecC& X1, VecC& X2, VecC& X3)
{
   VecC		dX1, dX2;
   double	x, d;

   dX1 = X2 - X1;
   dX2 = X3 - X2;
   // 
   x = dX1[0] * dX2[1] - dX1[1] * dX2[0];
   d = sqrt((dX1[0]*dX1[0] + dX1[1]*dX1[1]) * (dX2[0]*dX1[0] + dX2[1]*dX1[1]));

   return fabs(x / d);
}

// ƥ
int
colintest(CrpPair cp[], VecC Xa0[], VecC Xb0[], int idx[], int N)
{
   double	sina, sinb;

   for (int i = 0, j = 1, k = 2; i < N; i++, j++, k++)
   {
      if (j >= N)  j = 0;
      if (k >= N)  k = 0;
      sina = ang(Xa0[cp[idx[i]].a], Xa0[cp[idx[j]].a], Xa0[cp[idx[k]].a]);
      sinb = ang(Xb0[cp[idx[i]].b], Xb0[cp[idx[j]].b], Xb0[cp[idx[k]].b]);
      if (sina <= 0.05 || sinb <= 0.05)
      {
//	 cerr << "sin(" << i << "," << j << "," << k << ") = "
//	      << sina << ", " << sinb << endl;
	 return 0;
      }
   }

   return 1;
}

//// бƥ

// ؿ
static int
sgn(VecC& X1, VecC& X2, VecC& X3)
{
   VecC		dX1, dX2;
   double	x;

   dX1 = X2 - X1;
   dX2 = X3 - X2;
   // 
   x = dX1[0] * dX2[1] - dX1[1] * dX2[0];

   if (x > EPS)   return 1;
   if (x < -EPS)  return -1;
   return 0;
}

// ƥ
int
signtest(CrpPair cp[], VecC Xa0[], VecC Xb0[], int idx[], int N)
{
   int	sgna, sgnb;

   for (int i = 0, j = 1, k = 2; i < N; i++, j++, k++)
   {
      if (j >= N)  j = 0;
      if (k >= N)  k = 0;
      sgna = sgn(Xa0[cp[idx[i]].a], Xa0[cp[idx[j]].a], Xa0[cp[idx[k]].a]);
      sgnb = sgn(Xb0[cp[idx[i]].b], Xb0[cp[idx[j]].b], Xb0[cp[idx[k]].b]);
      if (sgna != sgnb)
      {
//	 cerr << "sign(" << i << "," << j << "," << k << ") = "
//	      << sgna << ", " << sgnb << endl;
	 return 0;
      }
   }

   return 1;
}

//// եѴƥ
static int
affmattest(const Mat& A, int n, int m, double f0)
{
   double	d, d1, d2;

   if (fabs(A[0][2]) >= n/(2.0 * f0))
   {
//      cerr << "affmattest 1: fabs(A13) = " << fabs(A[0][2]) << endl;
      return 0;
   }
   if (fabs(A[1][2]) >= m/(2.0 * f0))
   {
//      cerr << "affmattest 2: fabs(A23) = " << fabs(A[1][2]) << endl;
      return 0;
   }

   d = A[0][0] * A[1][1] - A[1][0] * A[0][1];
   if (d <= 0.5 || d >= 2)
   {
//      cerr << "affmattest 3: d = " << d << endl;
      return 0;
   }

   d1 = sqrt(A[0][0] * A[0][0] + A[1][0] * A[1][0]);
   if (d1 <= 0.7 || d1 >= 1.4)
   {
//      cerr << "affmattest 4: d1 = " << d1 << endl;
      return 0;
   }

   d2 = sqrt(A[0][1] * A[0][1] + A[1][1] * A[1][1]);
   if (d2 <= 0.7 || d2 >= 1.4)
   {
//      cerr << "affmattest 5: d2 = " << d2 << endl;
      return 0;
   }

   d = fabs((A[0][0] * A[0][1] + A[1][0] * A[1][1]) / (d1 * d2));
   if (d >= 0.5)
   {
//      cerr << "affmattest 6: d = " << d << endl;
      return 0;
   }

   return 1;
}

//// եƥ
int
affinetest(CrpPair cp[], VecC Xa0[], VecC Xb0[], int idx[], int N,
	   int width, int height, double f0)
{
   Mat	A;
   VecC	Xa[N], Xb[N];
   int	ret;

   // бμФ
   for (int i = 0; i < N; i++)
   {
      Xa[i].realloc(2);
      Xb[i].realloc(2);
      Xa[i][0] = f0 * Xa0[cp[idx[i]].a][0];
      Xa[i][1] = f0 * Xa0[cp[idx[i]].a][1];
      Xb[i][0] = f0 * Xb0[cp[idx[i]].b][0];
      Xb[i][1] = f0 * Xb0[cp[idx[i]].b][1];
   }
   // եѴ׻
   calc_affine_ls(Xa, Xb, f0, N, A);

   // եѴƥ
   ret = affmattest(A, height, width, f0);

   return ret;
}

//// ͱѴƥ
int
homotest(const Mat& H, int n, int m, double f0)
{
   double	d, d1, d2;

   if (fabs(H[0][2] / H[2][2]) < n/(2.0 * f0))
      return 1;
   if (fabs(H[1][2] / H[2][2]) < m/(2.0 * f0))
      return 1;

   d = (H[0][0] * H[1][1] - H[1][0] * H[0][1]) / (H[2][2] * H[2][2]);
   if (d > 0.5 && d < 2)
      return 1;

   d1 = sqrt(H[0][0] * H[0][0] + H[1][0] * H[1][0]);
   d2 = sqrt(H[0][1] * H[0][1] + H[1][1] * H[1][1]);
   d = fabs((H[0][0] * H[0][1] + H[1][0] * H[1][1]) / (d1 * d2));
   d1 /= H[2][2];
   d2 /= H[2][2];

   if ((d1 > 0.7) && (d1 < 1.4))
      return 1;

   if ((d2 > 0.7) && (d2 < 1.4))
      return 1;

   if (d > 0.7)
      return 1;
   
   if (((H[2][0] * H[2][0] + H[2][1] * H[2][1]) / (H[2][2] * H[2][2]))
       < ((4.0 * f0 * f0) / (n * n + m * m)))
      return 1;

   return 0;
}

//// ùΥ󥯥ƥ
int
ranktest_f(const Mat& F)
{
   double	detf, sg;
   Mat		EgVec;
   VecC		EgVal;

   detf = fabs(det33(F));
   eigen_vector(F*(~F), EgVec, EgVal);
   sg = EgVal[2];

   cerr << "|det F| = " << detf << ",\t"
	<< "sg_min = " << sg << endl;

   return 1;
}
