//
// μưбդ(ver.2.1)
//	ʿ14ǯ81

// ƥץ졼ȥޥå󥰤ˤбդ

#include <cstdlib>

#include "Mat.h"

#include "Image.h"
#include "CImage.h"
#include "Corresp_cls.h"
#include "Harris.h"
#include "sort_funcs.h"
#include "init_match.h"

// 2
static inline double
sqr(double x)
{
   return x * x;
}

// ƥץ졼(1)2ħޤΰȤλĺʿ
static double
residual(RealTemplate& Ta, RealTemplate& Tb)
{
   double	s, d, b;
   int		sx, sy, ex, ey;

   sx = Ta.xmin();
   ex = Ta.xmax();
   sy = Ta.ymin();
   ey = Ta.ymax();
   
   s = 0.0;

   for (int y = sy; y <= ey; y++)
      for (int x = sx; x <= ex; x++)
      {
	 b = Ta.get_im_pixel(x, y);
	 d = Tb.get_im_pixel(x, y);
	 if (b < 0.0 || d < 0.0)	// ϰϳ
	    return MISMATCH;
	 s += sqr(b - d);
      }
   return s;
}

// бɽκ
static int
make_table(RealTemplate *Ta, Point pa[], int Na,
	   RealTemplate *Tb, Point pb[], int Nb,
	   CrpPair cp[])
{
   int		N;
   double	r;

   cp[0].a = cp[0].b = cp[0].flag = 0;
   cp[0].Jlmd = cp[0].P0lmd = cp[0].P1lmd = cp[0].P2lmd = cp[0].Plmd = 0.0;
   N = 0;
   for (int a = 0; a < Na; a++)
      for (int b = 0; b < Nb; b++)
      {
	 // ñĺ(Ť̵)
	 r = residual(Ta[a], Tb[b]);
	 if (r >= 0.0)
	 {
	    N++;
	    cp[N].a = a;
	    cp[N].b = b;
	    cp[N].Jlmd = r;
	 }
      }

   return N;
}

// ̥ƥץ졼Ȥκ
static int
set_template(Image& Im, RealTemplate& T, Point& p, int normflag)
{
   int		sy, ey, sx, ex;
   double	d, s;
   
   sy = T.ymin(); ey = T.ymax();
   sx = T.xmin(); ex = T.xmax();
   s = 0.0;
   for (int j = sy; j <= ey; j++)
      for (int i = sx; i <= ex; i++)
      {
	 d = (double)Im.get_im_pixel2(p.u+i, p.v+j);
	 if (d < 0.0)
	    return 0;
	 T.put_im_pixel(i, j, d);
	 s += d * d;
      }

   // ƥץ졼Ȥκ
   if (normflag)
   {
      s = sqrt(s);
      for (int j = sy; j <= ey; j++)
	 for (int i = sx; i <= ex; i++)
	 {
	    d = T.get_im_pixel(i, j);
	    T.put_im_pixel(i, j, d / s);
	 }
   }

   return 1;
}

// ħޤΰ褫ƥץ졼Ȥ
static void
set_feature_templates(Image &Im, Point p[], int *Np,
		      RealTemplate **T, int Tsize, int normflag)
{
   int		i, j;

   *T = new RealTemplate [*Np];

   // ƥץ졼ȤΥꥵ(ɬפʤ)
   if ((*T)[0].xl() != (2 * Tsize + 1))
   {
      for (i = 0; i < (*Np); i++)
	 (*T)[i].resize(Tsize, Tsize);
   }

   // ƥץ졼Ⱥ
   j = 0;
   for (i = 0; i < (*Np); i++, j++)
   {
      // ΰƤäƤƥץ졼ȤΤͭȤ
      while (!set_template(Im, (*T)[j], p[i], normflag))
      {
	 if (++i >= (*Np)) goto END;
      }
      p[j].u = p[i].u;
      p[j].v = p[i].v;
   }

  END:
   *Np = j;
}

// ħ
static void
feature_extraction(Image &Im, int Pmax, Point **p, int *N, int ImpHrsFlg)
{
   int		*u, *v;

   // 쥤Ѵ
   if (ImpHrsFlg)
      ImpHarris(Im, &u, &v, N, H_Ns, H_sg, H_rk, H_s, Pmax, H_mindist);
   else
      Harris(Im, &u, &v, N, H_Ns, H_sg, H_rk, H_s, Pmax, H_mindist);

   *p = new Point [*N];

   // ħ֤Υԡ
   for (int i = 0; i < *N; i++)
   {
      (*p)[i].u = u[i];
      (*p)[i].v = v[i];
   }

   delete [] u;
   delete [] v;
}

// б׻
void
initial_matching(Image& Ima, Image& Imb,
		 Point **pa, Point **pb, int* Na, int* Nb,
		 CrpPair **cp0, int* N, int Pmax, int ImpHrsFlg,
		 int t_size, int normflag)
{
   RealTemplate	*Ta, *Tb;
   CrpPair	*cp;

   // ƲħФ
   feature_extraction(Ima, Pmax, pa, Na, ImpHrsFlg);
   feature_extraction(Imb, Pmax, pb, Nb, ImpHrsFlg);

   // ħޤΰƥץ졼ȤȤƼФ
   set_feature_templates(Ima, *pa, Na, &Ta, t_size, normflag);
   set_feature_templates(Imb, *pb, Nb, &Tb, t_size, normflag);

   // бɽ롥
   *cp0 = cp = new CrpPair [(*Na) * (*Nb) + 1];
   *N = make_table(Ta, *pa, *Na, Tb, *pb, *Nb, cp);

   // ĺǥ
   qsort(cp + 1, *N, sizeof(CrpPair), cmpJ);
}
