//
// μưбդ(ver.1.3)
//	ʿ14ǯ615

#include        <cstdlib>

#include	"Mat.h"

#include	"Corresp_cls.h"
#include	"sort_funcs.h"
#include	"homography.h"
#include	"fundamental.h"
#include	"eval_cnstr.h"
#include	"enforce_uniq.h"

// {áͱѴ}κƤϤ
void
recalc_FH(CrpPair cp[], int N,
	  VecC Xa0[], VecC Xb0[],
	  double dthd, double kthd, double fl, Mat& Fm,
	  CrpPair **ncp, int *Nn, VecC **Xan, VecC **Xbn,
	  Mat& Fn, Mat& Hn)
{
   VecC		*Xa, *Xb;
   double	*p;
   int		Nc, k;
   double	J;
   double	epsh;
   int		cnt;

   // ĺκƷ׻
   Nc = 0;
   for (int i = 1; i <= N; i++)
   {
      J = calc_J_lambda_fund(Fm, Xa0[cp[i].a], Xb0[cp[i].b]);
      if (J <= dthd)
	 cp[i].flag = 1;
      else
	 cp[i].flag = 0;
   }

   qsort(cp + 1, N, sizeof(CrpPair), cmpPl);

   *Nn = Nc = extract_one2one_pair(cp, N, kthd, ncp);
   *Xan = Xa = new VecC [Nc];
   *Xbn = Xb = new VecC [Nc];
   p = new double [Nc];
   *Nn = Nc;

   k = 0;
   for (int i = 1; i <= N; i++)
   {
      if (cp[i].flag)
      {
         Xa[k] = Xa0[cp[i].a];
         Xb[k] = Xb0[cp[i].b];
	 p[k] = 1.0;
         k++;
      }
   }

// ΨդǺƷ׻
   calc_fundamental(Xa, Xb, p, Nc, Fn, 2, 1e-10, 30);
   calc_homography(Xa, Xb, p, Nc, Hn, 2, 1e-10, 30, &epsh, &cnt);
}

// ͱѴκƤϤ
void
rematch_and_calc_H(CrpPair cp[], int N, VecC Xa0[], VecC Xb0[],
		   double dthd, double kthd, double fl, Mat& H0, Mat& H,
		   CrpPair **ncp, int *Nn)
{
   VecC		*Xa, *Xb;
   int		Nc, k;
   double	J, epsh;
   int		cnt;

   // ĺκƷ׻
   Nc = 0;
   for (int i = 1; i <= N; i++)
   {
      cp[i].Plmd = cp[i].P0lmd;
      J = calc_J_lambda_homo(H0, Xa0[cp[i].a], Xb0[cp[i].b], 0);
      if (J <= dthd && cp[i].Plmd > kthd)
      {
	 Nc++;
	 cp[i].flag = 1;
      }
      else
	 cp[i].flag = 0;
   }

   // P0 ǥ
   qsort(cp + 1, N, sizeof(CrpPair), cmpPl);

   Xa = new VecC [Nc];
   Xb = new VecC [Nc];
   *ncp = new CrpPair [Nc + 1];
   *Nn = Nc;

   (*ncp)[0] = cp[0];
   k = 0;
   for (int i = 1; i <= N; i++)
   {
      if (cp[i].flag)
      {
	 Xa[k] = Xa0[cp[i].a];
	 Xb[k] = Xb0[cp[i].b];
	 k++;
	 (*ncp)[k].a = cp[i].a;
	 (*ncp)[k].b = cp[i].b;
      }
   }

   calc_homography(Xa, Xb, Nc, H, 2, 1e-10, 30, &epsh, &cnt);
}
