//
// μưбդ(ver.1.3)
//	ʿ14ǯ615

// «˴ؤΨͤ

#include <iostream>
#include <cstdlib>
#include <cmath>

using namespace std;

#include "Mat.h"
#include "Corresp_cls.h"
#include "homography.h"
#include "fundamental.h"
#include "set_probs.h"
#include "sort_funcs.h"

// ƤϤĺ D_lambda Ф릵(t)η׻

// L İʲλĺʿ
static double
calc_Davg_L(CrpPair cp[], int L)
{
   double	Dm;

   Dm = 0.0;
   for (int i = 1; i <= L; i++)
      Dm += cp[i].Dlmd;

   return Dm / (double)L;
}

// ؿ(t)
static double
Phi_t(CrpPair cp[], int N, double Dm, double t)
{
   double	phit, u;

   phit = 0.0;
   for (int i = 1; i <= N; i++)
   {
      u = (cp[i].Dlmd - Dm) * exp(- (t * cp[i].Dlmd));
      if (fabs(u) < 1e-15)
	 break;
      phit += u;
   }

   return phit;
}

// ؿ'(t)
static double
dPhi_t(CrpPair cp[], int N, double Dm, double t)
{
   double	dphit, u;

   dphit = 0.0;
   for (int i = 1; i <= N; i++)
   {
      u = - cp[i].Dlmd * (cp[i].Dlmd - Dm) * exp(- (t * cp[i].Dlmd));
      if (fabs(u) < 1e-15)
	 break;
      dphit += u;
   }

   return dphit;
}

// t õ ˥塼ȥˡ
double
newton_search_t(CrpPair cp[], int N, int L)
{
   double	t, dt;
   double	Dm;
   int		c;

   Dm = calc_Davg_L(cp, L);
   c = 0;
   t = 0.0;

   while (++c < 30)
   {
      dt = Phi_t(cp, N, Dm, t) / dPhi_t(cp, N, Dm, t);
      if (fabs(dt) < S_EPS) break;
      t -= dt;
   }

   if (c >= 30)
   {
      cerr << "Warning in newton_search_t(): Exceed maximum iteration,"
	   << "and reset t = 0" << endl;
      t = 0.0;
   }

   return t;
}

// «γΨ P2_lambda η׻
void
set_P2lmd(CrpPair cp[], int N, int N1, int L)
{
   double	t;

   // 
   qsort(cp + 1, N, sizeof(CrpPair), cmpDl);

   t = newton_search_t(cp, N, L);
   for (int i = 1; i <= N; i++)
      cp[i].P2lmd = exp(- t * cp[i].Dlmd);
}
