//
// μưбդ(ver.1.3)
//	ʿ14ǯ615

// ƥץ졼ȥޥå󥰻ĺѤ٤
// ĺ˴ؤΨͤ

#include <iostream>
#include <cmath>

using namespace std;

#include "Mat.h"
#include "Corresp_cls.h"
#include "set_probs.h"

// ƥץ졼ȥޥå󥰻ĺ J_lambda Ф릵(s)η׻

// L İʲλĺʿ
static double
calc_Javg_L(CrpPair cp[], int L)
{
   double	Jm;

   Jm = 0.0;
   for (int i = 1; i <= L; i++)
      Jm += cp[i].Jlmd;

   return Jm / (double)L;
}

// ٴؿ(s)
static double
Phi_s(CrpPair cp[], int N, double Jm, double s)
{
   double	phis, t;

   phis = 0.0;
   for (int i = 1; i <= N; i++)
   {
      t = (cp[i].Jlmd - Jm) * exp(- (s * cp[i].Jlmd));
      if (fabs(t) < 1e-15)
	 break;
      phis += t;
   }

   return phis;
}

// ؿ'(s)
static double
dPhi_s(CrpPair cp[], int N, double Jm, double s)
{
   double	dphis, t;

   dphis = 0.0;
   for (int i = 1; i <= N; i++)
   {
      t = - cp[i].Jlmd * (cp[i].Jlmd - Jm) * exp(- (s * cp[i].Jlmd));
      if (fabs(t) < 1e-15)
	 break;
      dphis += t;
   }

   return dphis;
}

// s õ: ˥塼ȥˡ
double
newton_search_s(CrpPair cp[], int N, int L)
{
   double	s, ds;
   double	Jm;
   int		c;

   Jm = calc_Javg_L(cp, L);
//   cerr << "*** average L = " << Jm << endl;

   c = 0;
   s = 0.0;

   while (++c < 30)
   {
      ds = Phi_s(cp, N, Jm, s) / dPhi_s(cp, N, Jm, s);
      if (fabs(ds) < S_EPS) break;
      s -= ds;
//      cerr << " ** s = " << s << endl;
   }

   if (c > 30)
      cerr << "newton_search_s(): iteration exceeded!" << endl;

   return s;
}

// ĺ˴ؤΨ P0_lambda 
void
set_P0lmd(CrpPair cp[], int N, double s)
{
   // Ψ η׻
   cp[0].P0lmd = 0.0;
   for (int i = 1; i <= N; i++)
      cp[i].P0lmd = exp(- (s * cp[i].Jlmd));
}

// P0_lambda ꥻå(ƤγΨͤ 1 ˤ)
void
reset_P0lmd(CrpPair cp[], int N)
{
   for (int i = 1; i <= N; i++)
      cp[i].P0lmd = 1.0;
}
