//
// ħб(ץƥե)
//
#include <iostream>
#include <fstream>

using namespace std;

#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/time.h>

#define MAIN

#define	MAXLEN		256
#define	MAXPOINTS	65535

#define	DEFAULT_WIDTH	640
#define	DEFAULT_HEIGHT	480
#define	DEFAULT_RED	0.0
#define	DEFAULT_GREEN	0.0
#define	DEFAULT_BLUE	0.0
#define	DEFAULT_FRAME	1
#define	DEFAULT_GRAY	0.0


// ħκɸΥڥɤ߹ࡥ
int
read_points(char *filename, int width, int height,
	    double **x01, double **y01,
	    double **x02, double **y02)
{
   ifstream     data_file(filename);
   char		buff[MAXLEN];
   int          i, N;
   double       x1[MAXPOINTS], y1[MAXPOINTS];
   double       x2[MAXPOINTS], y2[MAXPOINTS];

   if (data_file.bad())
   {
      cerr << "Unable to open " << filename << endl;
      return 0;
   }

   i = 0;
   while (!data_file.eof())
   {
      data_file.getline(buff, MAXLEN);
      sscanf(buff, "(%lf,%lf)--(%lf,%lf)", &x1[i], &y1[i], &x2[i], &y2[i]);
      i++;
      if (i > MAXPOINTS)
	 break;
   }
   data_file.close();

   N = i - 1;
   *x01 = new double [N];
   *y01 = new double [N];
   *x02 = new double [N];
   *y02 = new double [N];

   for (i = 0; i < N; i++)
   {
      (*x01)[i] = x1[i];
      (*y01)[i] = y1[i];
      (*x02)[i] = x2[i];
      (*y02)[i] = y2[i];
   }

   return N;
}

void
write_header(int width, int height)
{
   cout << "%!PS-Adobe-2.0 EPSF-2.0" << endl;
   cout << "%%Creator: plot-corresp" << endl;
   cout << "%%Title: plot-corresp output" << endl;
   cout << "%%Pages: 1" << endl;
   cout << "%%BoundingBox: -1 -1 " << width + 1 << " " << height + 1 << endl;
   cout << "%%EndComments" << endl;
   cout << "%%Page: 1 1" << endl;
}

void
write_image_lines(int width, int height,
		  double *x1, double *y1, double *x2, double *y2, int N,
		  double r, double g, double b)
{
   double       ax, ay, bx, by;

   if (r == g && g == b)
      cout << r << " setgray" << endl;
   else
      cout << r << " " << g << " " << b << " setrgbcolor" << endl;

   cout << "[] 0 setdash" << endl;
   for (int i = 0; i < N; i++)
   {
      ax = x1[i];
      ay = height - y1[i];
      bx = x2[i];
      by = height - y2[i];

      cout << "newpath ";
      cout << ax << " " << ay << " 4 0 360 arc fill" << endl;

      cout << "newpath ";
      cout << ax << " " << ay << " moveto "
	   << bx << " " << by << " lineto"
	   << " stroke" << endl;
   }
}

void
write_footer()
{
   cout << "showpage" << endl;
   cout << "%%Trailer" << endl;
}

void
write_frame(int width, int height, double gray)
{
   cout << endl;
   cout << "newpath" << endl;
   cout << gray << " setgray" << endl;
   cout << "[] 0 setdash" << endl;
   cout << "0 0 moveto" << endl;
   cout << width << " 0 lineto" << endl;
   cout << width << " " << height << " lineto" << endl;
   cout << "0 " << height << " lineto" << endl;
   cout << "0 0 lineto" << endl;
   cout << "stroke" << endl;
   cout << endl;
}

void
write_ps(int width, int height,
	 double *x1, double *y1, double *x2, double *y2, int N,
	 double r, double g, double b,
	 int frame_flag, double gray)
{
   write_header(width, height);
   if (frame_flag)
      write_frame(width, height, gray);
   write_image_lines(width, height, x1, y1, x2, y2, N, r, g, b);
   write_footer();
}

int
main(int argc, char *argv[])
{
   int          ac;
   double	*x1, *y1, *x2, *y2;
   double       frame_gray, r, g, b;
   char         CP_name[80];
   int          width, height, N;
   int		frame_flag;

   if (argc != 2 && argc != 7 && argc != 8)
   {
      cerr << "Usage: plot-corresp corresp_file [width height r g b [frame_flag frame_gray]]" << endl;
      cerr << "DEFAULT: width = 640, height = 480, color = (1.0, 0.0, 0.0)" << endl;
      cerr << "\tframe_flag = 1(on), frame_gray = 0.0" << endl;
      return -1;
   }

   ac = 0;
   strcpy(CP_name, argv[++ac]);

   frame_flag = DEFAULT_FRAME;
   frame_gray = DEFAULT_GRAY;

   if (argc > 2)
   {
      width = atoi(argv[++ac]);
      height = atoi(argv[++ac]);
      r = atof(argv[++ac]);
      g = atof(argv[++ac]);
      b = atof(argv[++ac]);
      if (argc > 8)
      {
	 frame_flag = atoi(argv[++ac]);
	 frame_gray = atof(argv[++ac]);
      }
   }
   else
   {
      width = DEFAULT_WIDTH;
      height = DEFAULT_HEIGHT;
      r = DEFAULT_RED;
      g = DEFAULT_GREEN;
      b = DEFAULT_BLUE;
   }

   N = read_points(CP_name, width, height, &x1, &y1, &x2, &y2);
   write_ps(width, height, x1, y1, x2, y2, N, r, g, b, frame_flag, frame_gray);
}
